import java.util.Calendar;

import quadbase.reportdesigner.util.IExportConstants;
import quadbase.reportorganizer.organizerAPI.QbOrganizer;
import quadbase.reportorganizer.organizerAPI.QbScheduleObject;
import quadbase.reportorganizer.organizerAPI.QbSchedulePackage;

//Run this example from ERES install directory
public class SchedulingPackageFailedEmailERES {
	// set following constants, your ERES server must be runnning!
	static final String ServletRunner = "http://localhost:8080";
	static final String ServletContext = "ERES/servlet";

	public static void main(String[] args) {
		SchedulingPackageFailedEmailERES doSchedulePackage = new SchedulingPackageFailedEmailERES();
		try {
			doSchedulePackage.createScheduleObject();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	void createScheduleObject() throws Exception {
		QbOrganizer.setServletContext(ServletContext);
		QbOrganizer.setServletRunner(ServletRunner);
		QbOrganizer organizer = new QbOrganizer(null, "admin", "admin");

		QbSchedulePackage sPack = new QbSchedulePackage("Package_FailedEmail", organizer);
		sPack.setReportExportType(IExportConstants.PDF);
		sPack.setChartExportType(IExportConstants.PNG);
		sPack.setTaskOption(QbSchedulePackage.ONE_TIME);
		Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 10);
		sPack.setStartDate(calendar.getTimeInMillis());

		sPack.setSendEmail(true);
		sPack.setFromAddress("user1@quadbase.com");
		sPack.setSubject("Schedule Package Email");
		sPack.setBodyText("Schedule Package export containing a report and chart");
		sPack.setFailSubject("Package_FailedEmail schedule failed");
		sPack.setFailBodyText("Cannot send report and/or charts from Package_FailedEmail");
		sPack.setFailToAddress("user1@quadbase.com");
		sPack.setEmailType(QbSchedulePackage.ASATTACHMENT);

		QbScheduleObject rptObj = new QbScheduleObject("new project/Account",
				QbScheduleObject.TEMPLATE_TYPE_REPORT, sPack);
		rptObj.setFileLocation("Account.rpt");
		String exportLocation1 = rptObj.pickDefaultExportLocation();
		rptObj.setToAddresses(new String[] { "user2@quadbase.com" });

		QbScheduleObject chtObj = new QbScheduleObject("new project/col2d",
				QbScheduleObject.TEMPLATE_TYPE_CHART, sPack);
		chtObj.setFileLocation("col2d.tpl");
		String exportLocation2 = chtObj.pickDefaultExportLocation();
		chtObj.setToAddresses(new String[] { "user3@quadbase.com" });

		organizer.getScheduler().addSchedulePackageTask(sPack);
	}

}
